php 5.6 в ubuntu 16.04

Данный текст не претендует на то, чтобы быть руководством и является скорее памяткой самому себе.
Для некоторых сайтов понадобился php5, а в 16.04 устанавливается php7. Будем исправлять.

Скачаем нужную версию с http://museum.php.net/php5/ 

Для примера возьмем 5.6 который будем устанавливать в режиме PHP-FPM.

Сюда будем ставить mkdir /opt/php-5.6.24

Тут будем собирать mkdir /usr/local/src/php5-build

cd /usr/local/src/php5-build

Скачиваем нужную версию wget http://museum.php.net/php5/php-5.6.24.tar.bz2

И распаковываем tar jxf php-5.6.24.tar.bz2

Для сборки устанавливаем

apt-get install build-essential
apt-get build-dep php5
apt-get install libfcgi-dev libfcgi0ldbl libjpeg62-dbg libmcrypt-dev libssl-dev libc-client2007e libc-client2007e-dev

ln -s /usr/lib/libc-client.a /usr/lib/x86_64-linux-gnu/libc-client.a

Последнее, если собираем с --with-imap, иначе будем получать ошибку.

./configure \
--prefix=/opt/php-5.6.24 \
--with-zlib-dir \
--with-freetype-dir \
--enable-mbstring \
--with-libxml-dir=/usr \
--enable-soap \
--enable-calendar \
--with-curl \
--with-mcrypt \
--with-zlib \
--with-gd \
--disable-rpath \
--enable-inline-optimization \
--with-bz2 \
--with-zlib \
--enable-sockets \
--enable-sysvsem \
--enable-sysvshm \
--enable-pcntl \
--enable-mbregex \
--with-mhash \
--enable-zip \
--with-pcre-regex \
--with-mysql \
--with-pdo-mysql \
--with-mysqli \
--with-jpeg-dir=/usr \
--with-png-dir=/usr \
--enable-gd-native-ttf \
--with-openssl \
--with-fpm-user=www-data \
--with-fpm-group=www-data \
--with-libdir=/lib/x86_64-linux-gnu \
--enable-ftp \
--with-imap \
--with-imap-ssl \
--with-kerberos \
--with-gettext \
--enable-fpm

(тут, скорее всего, получим ряд ошибок, просто ставим те зависимости, на которые ругается)

make
make install

Копируем

cp /usr/local/src/php5-build/php-5.6.24/php.ini-production /opt/php-5.6.24/lib/php.ini
cp /opt/php-5.6.24/etc/php-fpm.conf.default /opt/php-5.6.24/etc/php-fpm.conf

Порт 9000 у нас занят седьмой версией. Открываем:

nano /opt/php-5.6.24/etc/php-fpm.conf

Исправляем 

[...]
pid = run/php-fpm.pid
[...]
user = www-data
group = www-data
[...]
listen = 127.0.0.1:8998
[...]
include=/opt/php-5.6.24/etc/pool.d/*.conf

Создаем: mkdir /opt/php-5.6.24/etc/pool.d

nano /etc/init.d/php-5.6.24-fpm

Содержимое:

#! /bin/sh
### BEGIN INIT INFO
# Provides:          php-5.6.24-fpm
# Required-Start:    $all
# Required-Stop:     $all
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: starts php-5.6.24-fpm
# Description:       starts the PHP FastCGI Process Manager daemon
### END INIT INFO
php_fpm_BIN=/opt/php-5.6.24/sbin/php-fpm
php_fpm_CONF=/opt/php-5.6.24/etc/php-fpm.conf
php_fpm_PID=/opt/php-5.6.24/var/run/php-fpm.pid
php_opts="--fpm-config $php_fpm_CONF"
wait_for_pid () {
        try=0
        while test $try -lt 35 ; do
                case "$1" in
                        'created')
                        if [ -f "$2" ] ; then
                                try=''
                                break
                        fi
                        ;;
                        'removed')
                        if [ ! -f "$2" ] ; then
                                try=''
                                break
                        fi
                        ;;
                esac
                echo -n .
                try=`expr $try + 1`
                sleep 1
        done
}
case "$1" in
        start)
                echo -n "Starting php-fpm "
                $php_fpm_BIN $php_opts
                if [ "$?" != 0 ] ; then
                        echo " failed"
                        exit 1
                fi
                wait_for_pid created $php_fpm_PID
                if [ -n "$try" ] ; then
                        echo " failed"
                        exit 1
                else
                        echo " done"
                fi
        ;;
        stop)
                echo -n "Gracefully shutting down php-fpm "
                if [ ! -r $php_fpm_PID ] ; then
                        echo "warning, no pid file found - php-fpm is not running ?"
                        exit 1
                fi
                kill -QUIT `cat $php_fpm_PID`
                wait_for_pid removed $php_fpm_PID
                if [ -n "$try" ] ; then
                        echo " failed. Use force-exit"
                        exit 1
                else
                        echo " done"
                       echo " done"
                fi
        ;;
        force-quit)
                echo -n "Terminating php-fpm "
                if [ ! -r $php_fpm_PID ] ; then
                        echo "warning, no pid file found - php-fpm is not running ?"
                        exit 1
                fi
                kill -TERM `cat $php_fpm_PID`
                wait_for_pid removed $php_fpm_PID
                if [ -n "$try" ] ; then
                        echo " failed"
                        exit 1
                else
                        echo " done"
                fi
        ;;
        restart)
                $0 stop
                $0 start
        ;;
        reload)
                echo -n "Reload service php-fpm "
                if [ ! -r $php_fpm_PID ] ; then
                        echo "warning, no pid file found - php-fpm is not running ?"
                        exit 1
                fi
                kill -USR2 `cat $php_fpm_PID`
                echo " done"
        ;;
        *)
                echo "Usage: $0 {start|stop|force-quit|restart|reload}"
                exit 1
        ;;
esac


chmod 755 /etc/init.d/php-5.6.24-fpm
update-rc.d php-5.6.24-fpm defaults
/etc/init.d/php-5.6.24-fpm start

Установим apc, memcache и memcached

apt-get -y install php-pear

cd /opt/php-5.6.24/etc

pecl -C ./pear.conf update-channels

pecl -C ./pear.conf install apcu-4.0.11 

nano /opt/php-5.6.24/lib/php.ini
В конец: extension=apcu.so

pecl -C ./pear.conf install memcache

nano /opt/php-5.6.24/lib/php.ini
В конец: extension=memcache.so

apt-get install libmemcached-dev 
pecl -C ./pear.conf install memcached

nano /opt/php-5.6.24/lib/php.ini
В конец: extension=memcached.so

ionCube:
cd /tmp
wget http://downloads2.ioncube.com/loader_downloads/ioncube_loaders_lin_x86-64.tar.gz
tar xfvz ioncube_loaders_lin_x86-64.tar.gz
cp ioncube/ioncube_loader_lin_5.6.so /opt/phpfcgi-5.6.24/lib/php/extensions/no-debug-non-zts-20131226/ioncube.so

 

nano /opt/php-5.6.24/lib/php.ini
Самая первая строчка (Перед [PHP] )
zend_extension = /opt/php-5.6.24/lib/php/extensions/no-debug-non-zts-20131226/ioncube.so

Перезапуск /etc/init.d/php-5.6.24-fpm reload